% script to calculate a relative displacement of two points from the map of 
% displacements

% display the image and define the scale
newFigure = figure;
imshow(plottingData(1).originalImage)
axis image; %axis off;
xlabel({'Choose 2 points defining a certain distance by right-button';...
      'clicking your mouse, while zooming in by left-button clicking.'})
[position_x position_y] = ginput2(2);
close(newFigure)
plottingData(plottingData(1).nVirtualExtensometers).monitoringPoints = [position_x; position_y];

% find a position on the reduced colormap of displacements
selectedDisplacementPosition_1 = ceil([position_y(1), position_x(1)]/(plottingData(1).subsetSpacing+1));
selectedDisplacementPosition_2 = ceil([position_y(2), position_x(2)]/(plottingData(1).subsetSpacing+1));

% read the displacements at the selected locations and save them for all images
for i = 1:plottingData(1).nFiles
    
    avgValues_x1 = zeros(2*avgRadius+1);
    avgValues_x2 = zeros(2*avgRadius+1);
    avgValues_y1 = zeros(2*avgRadius+1);
    avgValues_y2 = zeros(2*avgRadius+1);
    
    a_counter = 0;
    for a = -avgRadius:avgRadius
        a_counter = a_counter+1;
        b_counter = 0;
        for b = -avgRadius:avgRadius
            b_counter = b_counter+1;
            avgValues_x1(a_counter,b_counter) = plottingData(i).displacements_x_scaled(max(1,selectedDisplacementPosition_1(1)+a),max(1,selectedDisplacementPosition_1(2)+b));
            avgValues_x2(a_counter,b_counter) = plottingData(i).displacements_x_scaled(max(1,selectedDisplacementPosition_2(1)+a),max(1,selectedDisplacementPosition_2(2)+b));
            avgValues_y1(a_counter,b_counter) = plottingData(i).displacements_y_scaled(max(1,selectedDisplacementPosition_1(1)+a),max(1,selectedDisplacementPosition_1(2)+b));
            avgValues_y2(a_counter,b_counter) = plottingData(i).displacements_y_scaled(max(1,selectedDisplacementPosition_2(1)+a),max(1,selectedDisplacementPosition_2(2)+b));
        end
    end
    
    x1 = mean(mean(avgValues_x1));
    x2 = mean(mean(avgValues_x2));
    y1 = mean(mean(avgValues_y1));
    y2 = mean(mean(avgValues_y2));
    
    plottingData(i).deltaX(plottingData(1).nVirtualExtensometers) = x2-x1;
    plottingData(i).deltaY(plottingData(1).nVirtualExtensometers) = y2-y1;
    
    deltaOriginal = plottingData(1).pxDistance*sqrt((position_x(2)-position_x(1))^2+(position_y(2)-position_y(1))^2);
    deltaAfterDeformation = sqrt((position_x(2)*plottingData(1).pxDistance+x2-x1-position_x(1)*plottingData(1).pxDistance)^2+(position_y(2)*plottingData(1).pxDistance+y2-y1-position_y(1)*plottingData(1).pxDistance)^2);
    %checkIfExtension = sign(deltaAfterDeformation-deltaOriginal); 
    %plottingData(i).deltaTot(plottingData(1).nVirtualExtensometers) = checkIfExtension*sqrt((x2-x1)^2+(y2-y1)^2);
    plottingData(i).deltaTot(plottingData(1).nVirtualExtensometers) = deltaAfterDeformation-deltaOriginal;
end