%% script to save data from virtual extensometers

exportFolderName = strcat('export/',plottingData(1).projectName,'/virtualExtensometer_',num2str(plottingData(1).actualExtensometer));
exportFileName_x = strcat(exportFolderName,'/',plottingData(1).projectName,'-virtExt_',num2str(plottingData(1).actualExtensometer),'_x-displacement (meters).txt');
exportFileName_y = strcat(exportFolderName,'/',plottingData(1).projectName,'-virtExt_',num2str(plottingData(1).actualExtensometer),'_y-displacement (meters).txt');
exportFileName_tot = strcat(exportFolderName,'/',plottingData(1).projectName,'-virtExt_',num2str(plottingData(1).actualExtensometer),'_totExtension (meters).txt');
deltas_X = zeros(plottingData(1).nFiles,1);
deltas_Y = zeros(plottingData(1).nFiles,1);
deltas_tot = zeros(plottingData(1).nFiles,1);

for i = 1:plottingData(1).nFiles
    deltas_X(i) = (plottingData(i).deltaX(plottingData(1).actualExtensometer));
    deltas_Y(i) = (plottingData(i).deltaY(plottingData(1).actualExtensometer));
    deltas_tot(i) = (plottingData(i).deltaTot(plottingData(1).actualExtensometer));
end

if ~isequal(exist(char(strcat('export/',plottingData(1).projectName)), 'dir'),7) % check whether the destination folder exists
    mkdir(strcat(pwd,'/export'),char(plottingData(1).projectName))
end
if ~isequal(exist(char(exportFolderName), 'dir'),7) % check whether the destination folder exists
    mkdir(strcat(pwd,char(strcat('/export/',plottingData(1).projectName))),char(strcat('/virtualExtensometer_',num2str(plottingData(1).actualExtensometer))))
end

dlmwrite(char(exportFileName_x), deltas_X)
dlmwrite(char(exportFileName_y), deltas_Y)
dlmwrite(char(exportFileName_tot), deltas_tot)

msgbox('All data saved successfuly');