function varargout = ncorr_post(varargin)
% NCORR_POST_v1_2 MATLAB code for ncorr_post.fig
%      NCORR_POST, by itself, creates a new NCORR_POST or raises the existing
%      singleton*.
%
%      H = NCORR_POST_v1_2 returns the handle to a new NCORR_POST or the handle to
%      the existing singleton*.
%
%      NCORR_POST('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in NCORR_POST.M with the given input arguments.
%
%      NCORR_POST('Property','Value',...) creates a new NCORR_POST or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before ncorr_post_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to ncorr_post_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help ncorr_post

% Last Modified by GUIDE v2.5 24-Jul-2014 15:30:47

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @ncorr_post_OpeningFcn, ...
                   'gui_OutputFcn',  @ncorr_post_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before ncorr_post is made visible.
function ncorr_post_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to ncorr_post (see VARARGIN)

% Choose default command line output for ncorr_post
handles.output = hObject;

% clear command window
clc

% save handles to mainGui and functions into root memory
setappdata(0,'handles_mainGui',gcf)                 % get handles to main GUI
setappdata(gcf, 'handles_updateAxes', @updateAxes)  % get handles to updateAxes function

% Add path to other folders
addpath(fullfile(pwd,'functions'))
addpath(fullfile(pwd,'files'))
addpath(fullfile(pwd,'export'))

% Remove axis
axis off

% prepare GUI
run initiateGUI_handles

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes ncorr_post wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = ncorr_post_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in pushbutton8 = Load data from Ncorr.
function pushbutton8_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton8 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = struct;

% get the Ncorr data
run getNcorrData_v1_2

set(handles.pushbutton21,'Enable', 'on')
set(handles.pushbutton18,'Enable', 'on')
set(handles.pushbutton10,'Enable', 'on')
set(handles.pushbutton3,'Enable', 'on')
set(handles.pushbutton6,'Enable', 'on')
set(handles.pushbutton5,'Enable', 'on')
set(handles.pushbutton1,'Enable', 'on')
set(handles.pushbutton2,'Enable', 'on')
set(handles.pushbutton22,'Enable', 'on')
set(handles.pushbutton23,'Enable', 'on')
set(handles.listbox1,'Enable', 'on')
set(handles.slider1,'Enable', 'on')
set(handles.edit2,'Enable', 'on')
set(handles.edit3,'Enable', 'on')
set(handles.edit4,'Enable', 'on')
set(handles.checkbox5,'Enable', 'on')

plottingData(1).currentImage = plottingData(1).nFiles; % display the last image
plottingData(1).currentQuantity = 1; % display strain xx
plottingData(1).transparency = 0.3;
plottingData(1).transparencyUnderArrows = 0.3;
plottingData(1).sizeOfArrows = 0.5;
plottingData(1).sizeOfArrowHeads = 0.5;
plottingData(1).principalGridDensity = 0.5;

set(handles.listbox1,'String', plottingData(1).quantitiesToDisplay)
set(handles.popupmenu1,'String', plottingData(1).extensometerColor)
set(handles.edit4,'String', sprintf('%d',plottingData(1).currentImage))

setappdata(handles_mainGui, 'plottingData', plottingData);
setappdata(handles_mainGui, 'handles', handles);

updateAxes


% --- Executes on selection change in listbox1.
function listbox1_Callback(hObject, eventdata, handles)
% hObject    handle to listbox1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns listbox1 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from listbox1

handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');

plottingData(1).currentQuantity = get(hObject,'Value');
plottingData(1).justInitialized = true;

setappdata(handles_mainGui, 'plottingData', plottingData);
updateAxes

if ~plottingData(1).isScaled && (plottingData(1).currentQuantity == 6 || plottingData(1).currentQuantity == 7)
    msgbox('The displacements have not been scaled to meters','Warning!')
end


% --- Executes during object creation, after setting all properties.
function listbox1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to listbox1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on button press in pushbutton1.
function pushbutton1_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');

if ~plottingData(1).plotArrows
    shortNotation = char(plottingData(1).shortNotation(plottingData(1).currentQuantity));
else
    shortNotation = 'principalArrows';
end
if plottingData(1).zoomed
    shortNotation = [shortNotation,'_zoom'];
end

imageName = extractExtension(plottingData(plottingData(1).currentImage).names);
exportFolderName = strcat('export/',plottingData(1).projectName,'/',shortNotation);
exportImageName = strcat(exportFolderName,'/',plottingData(1).projectName,'-',imageName,'_',shortNotation,'.png');

tempFigure = figure('Position', [100, 100, 800, 600]);
updateAxes_figureSaving

if ~isequal(exist(char(strcat('export/',plottingData(1).projectName)), 'dir'),7) % check whether the destination folder exists
    mkdir(strcat(pwd,'/export'),char(plottingData(1).projectName))
end
if ~isequal(exist(char(exportFolderName), 'dir'),7) % check whether the destination folder exists
    mkdir(strcat(pwd,char(strcat('/export/',plottingData(1).projectName))),shortNotation)
end

print(tempFigure,'-dpng',char(exportImageName))
close(tempFigure)
msgbox('Figure saved successfuly');


% --- Executes on button press in pushbutton2.
function pushbutton2_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');

progressbar(0)
for i = 1:plottingData(1).nFiles
    plottingData(1).currentImage = i;
    
    imageName = extractExtension(plottingData(plottingData(1).currentImage).names);
    exportFolderName = strcat('export/',plottingData(1).projectName,'/',plottingData(1).shortNotation(plottingData(1).currentQuantity));
    exportImageName = strcat(exportFolderName,'/',plottingData(1).projectName,'-',imageName,'_',...
        char(plottingData(1).shortNotation(plottingData(1).currentQuantity)),'.png');
    
    tempFigure = figure('Position', [100, 100, 800, 600]);
    setappdata(handles_mainGui, 'plottingData', plottingData);
    updateAxes_figureSaving
    if ~isequal(exist(char(strcat('export/',plottingData(1).projectName)), 'dir'),7) % check whether the destination folder exists
        mkdir(strcat(pwd,'/export'),char(plottingData(1).projectName))
    end
    if ~isequal(exist(char(exportFolderName), 'dir'),7) % check whether the destination folder exists
        mkdir(strcat(pwd,char(strcat('/export/',plottingData(1).projectName))),char(plottingData(1).shortNotation(plottingData(1).currentQuantity)))
    end
    
    print(tempFigure,'-dpng',char(exportImageName))
    close(tempFigure)
    progressbar(i/plottingData(1).nFiles)
end
msgbox('All figures saved successfuly');


% --- Executes on button press in pushbutton3.
function pushbutton3_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');

currentFolder = pwd;
run scaleDisplacements
plottingData(1).pxDistance = pxDistance; % distance between 2 pixels [m]

for i = 1:plottingData(1).nFiles
    plottingData(i).displacements_x_scaled = plottingData(i).displacements_x*plottingData(1).pxDistance;
    plottingData(i).displacements_y_scaled = plottingData(i).displacements_y*plottingData(1).pxDistance;
end
plottingData(1).isScaled = true;
set(handles.pushbutton4,'Enable', 'on')

setappdata(handles_mainGui, 'plottingData', plottingData);


% --- Executes on button press in pushbutton4.
function pushbutton4_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');

plottingData(1).nVirtualExtensometers = plottingData(1).nVirtualExtensometers+1;
if plottingData(1).nVirtualExtensometers == 7
    plottingData(1).nVirtualExtensometers = 1;
    set(handles.pushbutton11,'Enable', 'off')
    set(handles.pushbutton12,'Enable', 'off')
    set(handles.pushbutton13,'Enable', 'off')
    set(handles.pushbutton14,'Enable', 'off')
    set(handles.pushbutton15,'Enable', 'off')
    set(handles.pushbutton16,'Enable', 'off')
end
eval(strcat('set(handles.pushbutton',num2str(10+plottingData(1).nVirtualExtensometers),',''Enable'',''on'')'))
plottingData(1).actualExtensometer = plottingData(1).nVirtualExtensometers;

avgRadius = 10;
run calculateRelativeDisplacement

set(handles.pushbutton7,'Enable', 'on')
set(handles.pushbutton17,'Enable', 'on')
set(handles.pushbutton20,'Enable', 'on')
set(handles.checkbox4,'Enable', 'on')
set(handles.popupmenu1,'Enable', 'on')
setappdata(handles_mainGui, 'plottingData', plottingData);
updateAxes


% --- Executes on button press in pushbutton20.
function pushbutton20_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton20 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');

eval(strcat('set(handles.pushbutton',num2str(10+plottingData(1).nVirtualExtensometers),',''Enable'',''off'')'))
plottingData(1).nVirtualExtensometers = plottingData(1).nVirtualExtensometers-1;
plottingData(1).actualExtensometer = plottingData(1).nVirtualExtensometers;

if plottingData(1).nVirtualExtensometers == 0
    set(handles.pushbutton7,'Enable', 'off')
    set(handles.pushbutton17,'Enable', 'off')
    set(handles.pushbutton20,'Enable', 'off')
    set(handles.checkbox4,'Enable', 'off')
    set(handles.popupmenu1,'Enable', 'off')
end

setappdata(handles_mainGui, 'plottingData', plottingData);
updateAxes

% --- Executes on button press in pushbutton5.
function pushbutton5_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');

plottingData(1).currentImage = plottingData(1).currentImage-1;
set(handles.edit4,'String', sprintf('%d',plottingData(1).currentImage))

setappdata(handles_mainGui, 'plottingData', plottingData);
updateAxes


% --- Executes on button press in pushbutton6.
function pushbutton6_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');

plottingData(1).currentImage = plottingData(1).currentImage+1;
set(handles.edit4,'String', sprintf('%d',plottingData(1).currentImage))

setappdata(handles_mainGui, 'plottingData', plottingData);
updateAxes

% --- Executes on button press in pushbutton22.
function pushbutton22_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton22 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');

plottingData(1).currentImage = 1;
set(handles.edit4,'String', sprintf('%d',plottingData(1).currentImage))

setappdata(handles_mainGui, 'plottingData', plottingData);
updateAxes

% --- Executes on button press in pushbutton23.
function pushbutton23_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton23 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');

plottingData(1).currentImage = plottingData(1).nFiles;
set(handles.edit4,'String', sprintf('%d',plottingData(1).currentImage))

setappdata(handles_mainGui, 'plottingData', plottingData);
updateAxes


function edit4_Callback(hObject, eventdata, handles)
% hObject    handle to edit4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');

imNum = str2double(get(hObject,'String'));
plottingData(1).currentImage = min(max(imNum,1),plottingData(1).nFiles);
set(handles.edit4,'String', sprintf('%d',plottingData(1).currentImage))

setappdata(handles_mainGui, 'plottingData', plottingData);
updateAxes


% --- Executes during object creation, after setting all properties.
function edit4_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton7.
function pushbutton7_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton7 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');

run saveExtensometerData


% --- Executes on button press in pushbutton9.
function pushbutton9_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton9 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');

[inputFileName,inputPath] = uigetfile({'*.mat'},'MultiSelect', 'off',...
    'Select the project',[pwd,'/savedProjects']);

load([inputPath,inputFileName])

set(handles.listbox1,'String', plottingData(1).quantitiesToDisplay)
set(handles.popupmenu1,'String', plottingData(1).extensometerColor)

run initiateGUI_handles
run loadGUI_handles

set(handles.edit4,'String', sprintf('%d',plottingData(1).currentImage))

setappdata(handles_mainGui, 'plottingData', plottingData);
setappdata(handles_mainGui, 'handles', handles);
updateAxes


% --- Executes on button press in pushbutton10.
function pushbutton10_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton10 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');

% msgbox
handles_msgBox = msgbox('This may take a while, please wait...','Saving the project');

% saving the files
save(strcat('savedProjects/',char(plottingData(1).projectName),'.mat'),'plottingData') 
run saveGUI_handles 
close(handles_msgBox)

setappdata(handles_mainGui, 'plottingData', plottingData);
updateAxes


% --- Executes on slider movement.
function slider1_Callback(hObject, eventdata, handles)
% hObject    handle to slider1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');

plottingData(1).transparency = get(hObject,'Value');

setappdata(handles_mainGui, 'plottingData', plottingData);
updateAxes


% --- Executes during object creation, after setting all properties.
function slider1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slider1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end

function edit2_Callback(hObject, eventdata, handles)
% hObject    handle to edit2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');

plottingData(1).lowerBound = str2double(get(hObject,'String'));

setappdata(handles_mainGui, 'plottingData', plottingData);
updateAxes

% Hints: get(hObject,'String') returns contents of edit2 as text
%        str2double(get(hObject,'String')) returns contents of edit2 as a double


% --- Executes during object creation, after setting all properties.
function edit2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function edit3_Callback(hObject, eventdata, handles)
% hObject    handle to edit3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');

plottingData(1).upperBound = str2double(get(hObject,'String'));

setappdata(handles_mainGui, 'plottingData', plottingData);
updateAxes

% --- Executes during object creation, after setting all properties.
function edit3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on button press in checkbox1.
function checkbox1_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');

plottingData(1).autoscaleBounds = get(hObject,'Value');

setappdata(handles_mainGui, 'plottingData', plottingData);
updateAxes

% --- Executes on button press in checkbox3.
function checkbox3_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');

plottingData(1).showOutOfRoi = get(hObject,'Value');

setappdata(handles_mainGui, 'plottingData', plottingData);
updateAxes

% --- Executes on button press in checkbox4.
function checkbox4_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');

plottingData(1).plotExtensometers = get(hObject,'Value');

setappdata(handles_mainGui, 'plottingData', plottingData);
updateAxes

% --- Executes on button press in pushbutton17.
function pushbutton17_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton17 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');

run plotExtensometers

%% Pushbuttons 1 to 6 to swich between individual extensometers

% --- Executes on button press in pushbutton11.
function pushbutton11_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton11 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');
plottingData(1).actualExtensometer = 1;
setappdata(handles_mainGui, 'plottingData', plottingData);
updateAxes


% --- Executes on button press in pushbutton12.
function pushbutton12_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton12 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');
plottingData(1).actualExtensometer = 2;
setappdata(handles_mainGui, 'plottingData', plottingData);
updateAxes


% --- Executes on button press in pushbutton13.
function pushbutton13_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton13 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');
plottingData(1).actualExtensometer = 3;
setappdata(handles_mainGui, 'plottingData', plottingData);
updateAxes


% --- Executes on button press in pushbutton14.
function pushbutton14_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton14 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');
plottingData(1).actualExtensometer = 4;
setappdata(handles_mainGui, 'plottingData', plottingData);
updateAxes


% --- Executes on button press in pushbutton15.
function pushbutton15_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton15 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');
plottingData(1).actualExtensometer = 5;
setappdata(handles_mainGui, 'plottingData', plottingData);
updateAxes

% --- Executes on button press in pushbutton16.
function pushbutton16_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton16 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');
plottingData(1).actualExtensometer = 6;
setappdata(handles_mainGui, 'plottingData', plottingData);
updateAxes


%% ---- SETTINGS OF ARROWS AS INDICATORS OF PRINCIPAL STRAIN ---------%% 

% --- Executes on button press in checkbox5.
function checkbox5_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');

plottingData(1).plotArrows = get(hObject,'Value');
if plottingData(1).plotArrows
    set(handles.listbox1,'Enable', 'off')
    set(handles.slider1,'Enable', 'off')
    set(handles.slider2,'Enable', 'on')
    set(handles.slider3,'Enable', 'on')
    set(handles.slider4,'Enable', 'on')
    set(handles.slider5,'Enable', 'on')
else
    set(handles.listbox1,'Enable', 'on')
    set(handles.slider1,'Enable', 'on')
    set(handles.slider2,'Enable', 'off')
    set(handles.slider3,'Enable', 'off')
    set(handles.slider4,'Enable', 'off')
    set(handles.slider5,'Enable', 'off')
end

setappdata(handles_mainGui, 'plottingData', plottingData);
updateAxes


% --- Executes on slider movement.
function slider2_Callback(hObject, eventdata, handles)
% hObject    handle to slider2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');

plottingData(1).sizeOfArrows = get(hObject,'Value');
set(handles.slider2,'Enable', 'off')

setappdata(handles_mainGui, 'plottingData', plottingData);
updateAxes
set(handles.slider2,'Enable', 'on')


% --- Executes during object creation, after setting all properties.
function slider2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slider2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on slider movement.
function slider3_Callback(hObject, eventdata, handles)
% hObject    handle to slider3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');

plottingData(1).sizeOfArrowHeads = get(hObject,'Value');
set(handles.slider3,'Enable', 'off')

setappdata(handles_mainGui, 'plottingData', plottingData);
updateAxes
set(handles.slider3,'Enable', 'on')


% --- Executes during object creation, after setting all properties.
function slider3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slider3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end

% --- Executes on slider movement.
function slider4_Callback(hObject, eventdata, handles)
% hObject    handle to slider4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');

plottingData(1).principalGridDensity = get(hObject,'Value');
set(handles.slider4,'Enable', 'off')

setappdata(handles_mainGui, 'plottingData', plottingData);
updateAxes
set(handles.slider4,'Enable', 'on')


% --- Executes during object creation, after setting all properties.
function slider4_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slider4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end

% --- Executes on slider movement.
function slider5_Callback(hObject, eventdata, handles)
% hObject    handle to slider5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');

plottingData(1).transparencyUnderArrows = get(hObject,'Value');
set(handles.slider5,'Enable', 'off')

setappdata(handles_mainGui, 'plottingData', plottingData);
updateAxes
set(handles.slider5,'Enable', 'on')


% --- Executes during object creation, after setting all properties.
function slider5_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slider5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end

%%%%%%%%%%%%%%%%%%%%%%%%% ZOOMING SWITCH %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% --- Executes on button press in pushbutton18.
function pushbutton18_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton18 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');

tempFigure = figure('Position', [100, 100, 800, 600]);
updateAxes_figureSaving

zoomRect = round(getrect(gca)); zoomRect(3) = zoomRect(1)+zoomRect(3); zoomRect(4) = zoomRect(2)+zoomRect(4);
plottingData(1).zoomed = true;
plottingData(1).zoomFactor = (zoomRect(3)-zoomRect(1))/size(plottingData(1).roiOriginalImage,2);
plottingData(1).originOffset = [zoomRect(1), zoomRect(2)];
plottingData(1).zoomRect = zoomRect;

% extract the chosen rectangle from the image
plottingData(1).plot_x_zoomed = zoomRect(1):1:zoomRect(3); 
plottingData(1).plot_y_zoomed = zoomRect(2):1:zoomRect(4);
plottingData(1).roiOriginalImage_zoomed = plottingData(1).roiOriginalImage(...
    zoomRect(2):zoomRect(4),zoomRect(1):zoomRect(3),:);
plottingData(1).outOfRoiImage_zoomed = plottingData(1).outOfRoiImage(...
    zoomRect(2):zoomRect(4),zoomRect(1):zoomRect(3),:);
plottingData(1).roi_zoomed = plottingData(1).roi(...
    zoomRect(2):zoomRect(4),zoomRect(1):zoomRect(3),:);

% get the limits for plotted data (colormaps, vector fields)
relativeScaling = size(plottingData(1).displacements_x,2)/size(plottingData(1).roiOriginalImage,2);
plottingData(1).plot_x_quantities_zoomed = round(relativeScaling*[zoomRect(2), zoomRect(4)]);
plottingData(1).plot_y_quantities_zoomed = round(relativeScaling*[zoomRect(1), zoomRect(3)]);

close(tempFigure)

set(handles.pushbutton19,'Enable', 'on')
setappdata(handles_mainGui, 'plottingData', plottingData);
updateAxes

% --- Executes on button press in pushbutton19.
function pushbutton19_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton19 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');

plottingData(1).zoomed = false;

set(handles.pushbutton19,'Enable', 'off') % goes last to swith off after it is used
setappdata(handles_mainGui, 'plottingData', plottingData);
updateAxes

% --- Executes on selection change in popupmenu1.
function popupmenu1_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');

plottingData(1).currentExtColor = get(hObject,'Value');

setappdata(handles_mainGui, 'plottingData', plottingData);
updateAxes


% --- Executes during object creation, after setting all properties.
function popupmenu1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on button press in pushbutton21.
function pushbutton21_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton21 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');

progressbar(0)
for i = 1:plottingData(1).nFiles
    plottingData(1).currentImage = i;
    
    imageName = extractExtension(plottingData(plottingData(1).currentImage).names);
    exportFolderName = strcat('export/',plottingData(1).projectName,'/',plottingData(1).shortNotation(plottingData(1).currentQuantity));
    
    exportImageName = strcat(exportFolderName,'/',plottingData(1).projectName,'-',imageName,'_',...
        char(plottingData(1).shortNotation(plottingData(1).currentQuantity)),'.png');
    
    tempFigure = figure('Position', [100, 100, 800, 600]);
    setappdata(handles_mainGui, 'plottingData', plottingData);
    updateAxes_figureSaving
    if ~isequal(exist(char(strcat('export/',plottingData(1).projectName)), 'dir'),7) % check whether the destination folder exists
        mkdir(strcat(pwd,'/export'),char(plottingData(1).projectName))
    end
    if ~isequal(exist(char(exportFolderName), 'dir'),7) % check whether the destination folder exists
        mkdir(strcat(pwd,char(strcat('/export/',plottingData(1).projectName))),char(plottingData(1).shortNotation(plottingData(1).currentQuantity)))
    end
    
    print(tempFigure,'-dpng',char(exportImageName))
    close(tempFigure)
    progressbar(i/plottingData(1).nFiles)
end

% Make avi movie

exportVideoFolderName = strcat('export/',plottingData(1).projectName,'/video_',plottingData(1).shortNotation(plottingData(1).currentQuantity));
exportVideoName = strcat(exportVideoFolderName,'/',plottingData(1).projectName,'-video_',...
        char(plottingData(1).shortNotation(plottingData(1).currentQuantity)),'.avi');

if ~isequal(exist(char(exportVideoFolderName), 'dir'),7) % check whether the destination folder exists
    mkdir(strcat(pwd,char(strcat('/export/',plottingData(1).projectName)),'/video_',char(plottingData(1).shortNotation(plottingData(1).currentQuantity))))
end

writerObj = VideoWriter(char(exportVideoName));
writerObj.FrameRate = 4; % frames per second

open(writerObj);
for i = 1:plottingData(1).nFiles
    plottingData(1).currentImage = i;
    imageName = extractExtension(plottingData(plottingData(1).currentImage).names);
    imageToVideo = strcat(exportFolderName,'/',plottingData(1).projectName,'-',imageName,'_',...
        char(plottingData(1).shortNotation(plottingData(1).currentQuantity)),'.png');
    writeVideo(writerObj,imread(char(imageToVideo)));
end
close(writerObj);
implay(char(exportVideoName))

%% Function to update axes
function updateAxes
handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');
handles = getappdata(handles_mainGui, 'handles');

% plot the original image
if ~plottingData(1).zoomed
    handlesImage = imagesc(plottingData(1).plot_x,plottingData(1).plot_y,plottingData(1).roiOriginalImage);
else
    handlesImage = imagesc(plottingData(1).plot_x_zoomed,plottingData(1).plot_y_zoomed,plottingData(1).roiOriginalImage_zoomed);
end
axis off; axis image
hold on

% plotting the map or quiver
if plottingData(1).plotArrows
    imageSize = size(plottingData(1).roiOriginalImage);
    principalGridDensity = round(max(1,(1-plottingData(1).principalGridDensity)*min(size(plottingData(1).strains_xx))/4));
    sizeOfArrows = 10*plottingData(1).sizeOfArrows*min(imageSize(1),imageSize(2))/min(size(plottingData(1).strains_xx));
    maxLength = mean([mean(mean(abs(plottingData(plottingData(1).currentImage).strain_xx_princ))),...
        mean(mean(abs(plottingData(plottingData(1).currentImage).strain_xx_princ)))]);
    magnificationFactor = (sizeOfArrows)/maxLength;
    sizeOfArrowHeads = sizeOfArrows*plottingData(1).sizeOfArrowHeads;
    
    if ~plottingData(1).zoomed
        plotQuiverData(magnificationFactor,principalGridDensity,...
            plottingData(plottingData(1).currentImage).strain_xx_princ,...
            plottingData(plottingData(1).currentImage).strain_yy_princ,...
            plottingData(plottingData(1).currentImage).principalAngle,...
            imageSize,maxLength,sizeOfArrowHeads,[0,0])
        
        % switch the background off
        if plottingData(1).showOutOfRoi
            handlesImage_2 = imagesc(plottingData(1).plot_x,plottingData(1).plot_y,plottingData(1).outOfRoiImage,...
                'alphadata',plottingData(1).roi ~= 1);
        else
            handlesImage_2 = imagesc(plottingData(1).plot_x,plottingData(1).plot_y,plottingData(1).roiOriginalImage,...
                'alphadata',plottingData(1).roi ~= 1);
        end
        
        set(handlesImage,'AlphaData',(1-plottingData(1).transparencyUnderArrows)) % transparency settings
        set(handlesImage_2,'AlphaData',(1-plottingData(1).transparencyUnderArrows)*(plottingData(1).roi ~= 1)) % transparency settings
    else
        imageSize = size(plottingData(1).roiOriginalImage_zoomed);
        magnificationFactor = plottingData(1).zoomFactor*sizeOfArrows/maxLength;
        sizeOfArrowHeads = sizeOfArrows*plottingData(1).sizeOfArrowHeads;
        
        plotQuiverData(magnificationFactor,principalGridDensity,...
            plottingData(plottingData(1).currentImage).strain_xx_princ(plottingData(1).plot_x_quantities_zoomed(1):plottingData(1).plot_x_quantities_zoomed(2),plottingData(1).plot_y_quantities_zoomed(1):plottingData(1).plot_y_quantities_zoomed(2)),...
            plottingData(plottingData(1).currentImage).strain_yy_princ(plottingData(1).plot_x_quantities_zoomed(1):plottingData(1).plot_x_quantities_zoomed(2),plottingData(1).plot_y_quantities_zoomed(1):plottingData(1).plot_y_quantities_zoomed(2)),...
            plottingData(plottingData(1).currentImage).principalAngle(plottingData(1).plot_x_quantities_zoomed(1):plottingData(1).plot_x_quantities_zoomed(2),plottingData(1).plot_y_quantities_zoomed(1):plottingData(1).plot_y_quantities_zoomed(2)),...
            imageSize,maxLength,sizeOfArrowHeads,plottingData(1).originOffset)
        
        % switch the background off
        if plottingData(1).showOutOfRoi
            handlesImage_2 = imagesc(plottingData(1).plot_x_zoomed,plottingData(1).plot_y_zoomed,...
                plottingData(1).outOfRoiImage_zoomed,'alphadata',plottingData(1).roi_zoomed ~= 1);
        else
            handlesImage_2 = imagesc(plottingData(1).plot_x_zoomed,plottingData(1).plot_y_zoomed,...
                plottingData(1).roiOriginalImage_zoomed,'alphadata',plottingData(1).roi_zoomed ~= 1);
        end
        
        set(handlesImage,'AlphaData',(1-plottingData(1).transparencyUnderArrows)) % transparency settings
        set(handlesImage_2,'AlphaData',(1-plottingData(1).transparencyUnderArrows)*(plottingData(1).roi_zoomed ~= 1)) % transparency settings
    end
else
    if ~plottingData(1).zoomed
        eval(['quantityToPlot = ',char(plottingData(1).plotString(plottingData(1).currentQuantity)),';'])
        if ~plottingData(1).justInitialized
            plottingData(1).lowerBound = str2double(get(handles.edit2,'String'));
            plottingData(1).upperBound = str2double(get(handles.edit3,'String'));
            caxis([plottingData(1).lowerBound,plottingData(1).upperBound]); % sets limits to the colorbar
        end
        handles_map = imagesc(plottingData(1).plot_x,plottingData(1).plot_y,quantityToPlot); % plots the colormap
        colorbar % creates a colorbar
        set(handles_map,'AlphaData',(1-plottingData(1).transparency)) % transparency settings

        % switch the background off
        if plottingData(1).showOutOfRoi
            imagesc(plottingData(1).plot_x,plottingData(1).plot_y,plottingData(1).outOfRoiImage,...
                'alphadata',plottingData(1).roi ~= 1);
        else
            imagesc(plottingData(1).plot_x,plottingData(1).plot_y,plottingData(1).roiOriginalImage,...
                'alphadata',plottingData(1).roi ~= 1);
        end
    else
        eval(['quantityToPlot = ',char(plottingData(1).plotString(plottingData(1).currentQuantity)),...
            '(plottingData(1).plot_x_quantities_zoomed(1):plottingData(1).plot_x_quantities_zoomed(2),plottingData(1).plot_y_quantities_zoomed(1):plottingData(1).plot_y_quantities_zoomed(2));'])
        if ~plottingData(1).justInitialized
            plottingData(1).lowerBound = str2double(get(handles.edit2,'String'));
            plottingData(1).upperBound = str2double(get(handles.edit3,'String'));
            caxis([plottingData(1).lowerBound,plottingData(1).upperBound]); % sets limits to the colorbar
        end
        handles_map = imagesc(plottingData(1).plot_x_zoomed,plottingData(1).plot_y_zoomed,quantityToPlot); % plots the colormap
        colorbar % creates a colorbar
        set(handles_map,'AlphaData',(1-plottingData(1).transparency)) % transparency settings

        % switch the background off
        if plottingData(1).showOutOfRoi
            handlesImage_2 = imagesc(plottingData(1).plot_x_zoomed,plottingData(1).plot_y_zoomed,...
                plottingData(1).outOfRoiImage_zoomed,'alphadata',plottingData(1).roi_zoomed ~= 1);
        else
            handlesImage_2 = imagesc(plottingData(1).plot_x_zoomed,plottingData(1).plot_y_zoomed,...
                plottingData(1).roiOriginalImage_zoomed,'alphadata',plottingData(1).roi_zoomed ~= 1);
        end
    end
end

% disable previous / next step button for the first / last image
if plottingData(1).currentImage == plottingData(1).nFiles
    set(handles.pushbutton6,'Enable', 'off')
    set(handles.pushbutton23,'Enable', 'off')
    set(handles.pushbutton5,'Enable', 'on')
    set(handles.pushbutton22,'Enable', 'on')
elseif plottingData(1).currentImage == 1
    set(handles.pushbutton5,'Enable', 'off')
    set(handles.pushbutton22,'Enable', 'off')
    set(handles.pushbutton6,'Enable', 'on')
    set(handles.pushbutton23,'Enable', 'on')
else
    set(handles.pushbutton5,'Enable', 'on')
    set(handles.pushbutton6,'Enable', 'on')
    set(handles.pushbutton22,'Enable', 'on')
    set(handles.pushbutton23,'Enable', 'on')
end

imageName = extractExtension(plottingData(plottingData(1).currentImage).names);
handles_fileName = findobj('Style','text','Tag','text9'); % find handle of static text
set(handles_fileName,'String', imageName) % update the static text field

% on the first run (or if autoscaleBounds option is checked) set the lower and upper bounds
if ~plottingData(1).plotArrows
    if plottingData(1).justInitialized || plottingData(1).autoscaleBounds
        minToPlot = min(quantityToPlot(:));
        maxToPlot = max(quantityToPlot(:));
        plottingData(1).justInitialized = false;
        set(handles.edit2,'String', sprintf('%.9f',minToPlot))
        set(handles.edit3,'String', sprintf('%.9f',maxToPlot))
        caxis([minToPlot,maxToPlot]); % sets limits to the colorbar
    end
end

% display the data from virtual extensometers
if plottingData(1).monitoringPoints(1) > 0 && plottingData(1).nVirtualExtensometers ~= 0
    for i = 1:plottingData(1).nVirtualExtensometers
        if plottingData(1).zoomed
            if sum([plottingData(1).zoomRect(1) < plottingData(i).monitoringPoints(1:2); plottingData(1).zoomRect(3) > plottingData(i).monitoringPoints(1:2); plottingData(1).zoomRect(2) < plottingData(i).monitoringPoints(3:4); plottingData(1).zoomRect(4) > plottingData(i).monitoringPoints(3:4)]) == 8
                plot(plottingData(i).monitoringPoints(1:2),plottingData(i).monitoringPoints(3:4),'+','Color',plottingData(1).extensometerRGB(plottingData(1).currentExtColor,:),'MarkerSize',5)
                text(plottingData(i).monitoringPoints(1),plottingData(i).monitoringPoints(3),[' ',num2str(i)],'FontSize',9,'HorizontalAlignment','Left','VerticalAlignment','Middle','Margin',35,'FontWeight','demi','Color',plottingData(1).extensometerRGB(plottingData(1).currentExtColor,:))
                text(plottingData(i).monitoringPoints(2),plottingData(i).monitoringPoints(4),[' ',num2str(i)],'FontSize',9,'HorizontalAlignment','Left','VerticalAlignment','Middle','Margin',35,'FontWeight','demi','Color',plottingData(1).extensometerRGB(plottingData(1).currentExtColor,:))
            end
        else
            plot(plottingData(i).monitoringPoints(1:2),plottingData(i).monitoringPoints(3:4),'+','Color',plottingData(1).extensometerRGB(plottingData(1).currentExtColor,:),'MarkerSize',5)
            text(plottingData(i).monitoringPoints(1),plottingData(i).monitoringPoints(3),[' ',num2str(i)],'FontSize',9,'HorizontalAlignment','Left','VerticalAlignment','Middle','Margin',35,'FontWeight','demi','Color',plottingData(1).extensometerRGB(plottingData(1).currentExtColor,:))
            text(plottingData(i).monitoringPoints(2),plottingData(i).monitoringPoints(4),[' ',num2str(i)],'FontSize',9,'HorizontalAlignment','Left','VerticalAlignment','Middle','Margin',35,'FontWeight','demi','Color',plottingData(1).extensometerRGB(plottingData(1).currentExtColor,:))
        end
    end
    
    handles_deltaX = findobj('Style','text','Tag','text12'); % find handle of static text
    set(handles_deltaX,'String', num2str((plottingData(plottingData(1).currentImage).deltaX(plottingData(1).actualExtensometer))*1e3)) % update the static text field
    
    handles_deltaY = findobj('Style','text','Tag','text13'); % find handle of static text
    set(handles_deltaY,'String', num2str((plottingData(plottingData(1).currentImage).deltaY(plottingData(1).actualExtensometer))*1e3)) % update the static text field
    
    handles_deltaTot = findobj('Style','text','Tag','text14'); % find handle of static text
    set(handles_deltaTot,'String', num2str((plottingData(plottingData(1).currentImage).deltaTot(plottingData(1).actualExtensometer))*1e3)) % update the static text field
    
    % amplify the chosen virtual extensometer
    for i = 1:6
        eval(strcat('set(handles.pushbutton',num2str(10+i),',''FontWeight'', ''light'')'))
        eval(strcat('set(handles.pushbutton',num2str(10+i),',''ForegroundColor'', [0.3 0.3 0.3])'))
        eval(strcat('set(handles.pushbutton',num2str(10+i),',''FontSize'', 10.666)'))
    end
    eval(strcat('set(handles.pushbutton',num2str(10+plottingData(1).actualExtensometer),',''FontWeight'',''bold'')'))
    eval(strcat('set(handles.pushbutton',num2str(10+plottingData(1).actualExtensometer),',''ForegroundColor'',[0 0 0])'))
    eval(strcat('set(handles.pushbutton',num2str(10+plottingData(1).actualExtensometer),',''FontSize'',12)'))
else
    
    handles_deltaX = findobj('Style','text','Tag','text12'); % find handle of static text
    set(handles_deltaX,'String', ' ') % update the static text field
    
    handles_deltaY = findobj('Style','text','Tag','text13'); % find handle of static text
    set(handles_deltaY,'String', ' ') % update the static text field
    
    handles_deltaTot = findobj('Style','text','Tag','text14'); % find handle of static text
    set(handles_deltaTot,'String', ' ') % update the static text field
end
  
hold off
  
setappdata(handles_mainGui, 'plottingData', plottingData);
setappdata(handles_mainGui, 'handles', handles);


%% function to update axes when saving a figure

function updateAxes_figureSaving
handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');
handles = getappdata(handles_mainGui, 'handles');

% plot the original image
if ~plottingData(1).zoomed
    handlesImage = imagesc(plottingData(1).plot_x,plottingData(1).plot_y,plottingData(1).roiOriginalImage);
else
    handlesImage = imagesc(plottingData(1).plot_x_zoomed,plottingData(1).plot_y_zoomed,plottingData(1).roiOriginalImage_zoomed);
end
axis off; axis image
hold on

% plotting the map or quiver
if plottingData(1).plotArrows
    imageSize = size(plottingData(1).roiOriginalImage);
    principalGridDensity = round(max(1,(1-plottingData(1).principalGridDensity)*min(size(plottingData(1).strains_xx))/4));
    sizeOfArrows = 10*plottingData(1).sizeOfArrows*min(imageSize(1),imageSize(2))/min(size(plottingData(1).strains_xx));
    maxLength = mean([mean(mean(abs(plottingData(plottingData(1).currentImage).strain_xx_princ))),...
        mean(mean(abs(plottingData(plottingData(1).currentImage).strain_xx_princ)))]);
    magnificationFactor = (sizeOfArrows)/maxLength;
    sizeOfArrowHeads = sizeOfArrows*plottingData(1).sizeOfArrowHeads;
    
    if ~plottingData(1).zoomed
        plotQuiverData(magnificationFactor,principalGridDensity,...
            plottingData(plottingData(1).currentImage).strain_xx_princ,...
            plottingData(plottingData(1).currentImage).strain_yy_princ,...
            plottingData(plottingData(1).currentImage).principalAngle,...
            imageSize,maxLength,sizeOfArrowHeads,[0,0])
        
        % switch the background off
        if plottingData(1).showOutOfRoi
            handlesImage_2 = imagesc(plottingData(1).plot_x,plottingData(1).plot_y,plottingData(1).outOfRoiImage,...
                'alphadata',plottingData(1).roi ~= 1);
        else
            handlesImage_2 = imagesc(plottingData(1).plot_x,plottingData(1).plot_y,plottingData(1).roiOriginalImage,...
                'alphadata',plottingData(1).roi ~= 1);
        end
        
        set(handlesImage,'AlphaData',(1-plottingData(1).transparencyUnderArrows)) % transparency settings
        set(handlesImage_2,'AlphaData',(1-plottingData(1).transparencyUnderArrows)*(plottingData(1).roi ~= 1)) % transparency settings
    else
        imageSize = size(plottingData(1).roiOriginalImage_zoomed);
        magnificationFactor = plottingData(1).zoomFactor*sizeOfArrows/maxLength;
        sizeOfArrowHeads = sizeOfArrows*plottingData(1).sizeOfArrowHeads;
        
        plotQuiverData(magnificationFactor,principalGridDensity,...
            plottingData(plottingData(1).currentImage).strain_xx_princ(plottingData(1).plot_x_quantities_zoomed(1):plottingData(1).plot_x_quantities_zoomed(2),plottingData(1).plot_y_quantities_zoomed(1):plottingData(1).plot_y_quantities_zoomed(2)),...
            plottingData(plottingData(1).currentImage).strain_yy_princ(plottingData(1).plot_x_quantities_zoomed(1):plottingData(1).plot_x_quantities_zoomed(2),plottingData(1).plot_y_quantities_zoomed(1):plottingData(1).plot_y_quantities_zoomed(2)),...
            plottingData(plottingData(1).currentImage).principalAngle(plottingData(1).plot_x_quantities_zoomed(1):plottingData(1).plot_x_quantities_zoomed(2),plottingData(1).plot_y_quantities_zoomed(1):plottingData(1).plot_y_quantities_zoomed(2)),...
            imageSize,maxLength,sizeOfArrowHeads,plottingData(1).originOffset)
        
        % switch the background off
        if plottingData(1).showOutOfRoi
            handlesImage_2 = imagesc(plottingData(1).plot_x_zoomed,plottingData(1).plot_y_zoomed,...
                plottingData(1).outOfRoiImage_zoomed,'alphadata',plottingData(1).roi_zoomed ~= 1);
        else
            handlesImage_2 = imagesc(plottingData(1).plot_x_zoomed,plottingData(1).plot_y_zoomed,...
                plottingData(1).roiOriginalImage_zoomed,'alphadata',plottingData(1).roi_zoomed ~= 1);
        end
        
        set(handlesImage,'AlphaData',(1-plottingData(1).transparencyUnderArrows)) % transparency settings
        set(handlesImage_2,'AlphaData',(1-plottingData(1).transparencyUnderArrows)*(plottingData(1).roi_zoomed ~= 1)) % transparency settings
    end
else
    if ~plottingData(1).zoomed
        eval(['quantityToPlot = ',char(plottingData(1).plotString(plottingData(1).currentQuantity)),';'])
        if ~plottingData(1).justInitialized
            plottingData(1).lowerBound = str2double(get(handles.edit2,'String'));
            plottingData(1).upperBound = str2double(get(handles.edit3,'String'));
            caxis([plottingData(1).lowerBound,plottingData(1).upperBound]); % sets limits to the colorbar
        end
        handles_map = imagesc(plottingData(1).plot_x,plottingData(1).plot_y,quantityToPlot); % plots the colormap
        colorbar % creates a colorbar
        set(handles_map,'AlphaData',(1-plottingData(1).transparency)) % transparency settings

        % switch the background off
        if plottingData(1).showOutOfRoi
            imagesc(plottingData(1).plot_x,plottingData(1).plot_y,plottingData(1).outOfRoiImage,...
                'alphadata',plottingData(1).roi ~= 1);
        else
            imagesc(plottingData(1).plot_x,plottingData(1).plot_y,plottingData(1).roiOriginalImage,...
                'alphadata',plottingData(1).roi ~= 1);
        end
    else
        eval(['quantityToPlot = ',char(plottingData(1).plotString(plottingData(1).currentQuantity)),...
            '(plottingData(1).plot_x_quantities_zoomed(1):plottingData(1).plot_x_quantities_zoomed(2),plottingData(1).plot_y_quantities_zoomed(1):plottingData(1).plot_y_quantities_zoomed(2));'])
        if ~plottingData(1).justInitialized
            plottingData(1).lowerBound = str2double(get(handles.edit2,'String'));
            plottingData(1).upperBound = str2double(get(handles.edit3,'String'));
            caxis([plottingData(1).lowerBound,plottingData(1).upperBound]); % sets limits to the colorbar
        end
        handles_map = imagesc(plottingData(1).plot_x_zoomed,plottingData(1).plot_y_zoomed,quantityToPlot); % plots the colormap
        colorbar % creates a colorbar
        set(handles_map,'AlphaData',(1-plottingData(1).transparency)) % transparency settings

        % switch the background off
        if plottingData(1).showOutOfRoi
            handlesImage_2 = imagesc(plottingData(1).plot_x_zoomed,plottingData(1).plot_y_zoomed,...
                plottingData(1).outOfRoiImage_zoomed,'alphadata',plottingData(1).roi_zoomed ~= 1);
        else
            handlesImage_2 = imagesc(plottingData(1).plot_x_zoomed,plottingData(1).plot_y_zoomed,...
                plottingData(1).roiOriginalImage_zoomed,'alphadata',plottingData(1).roi_zoomed ~= 1);
        end
    end
end

% on the first run (or if autoscaleBounds option is checked) set the lower and upper bounds
if ~plottingData(1).plotArrows
    if plottingData(1).justInitialized || plottingData(1).autoscaleBounds
        minToPlot = min(quantityToPlot(:));
        maxToPlot = max(quantityToPlot(:));
        plottingData(1).justInitialized = false;
        set(handles.edit2,'String', sprintf('%.9f',minToPlot))
        set(handles.edit3,'String', sprintf('%.9f',maxToPlot))
        caxis([minToPlot,maxToPlot]); % sets limits to the colorbar
    end
end

% display marks for virtual extensometers
if plottingData(1).plotExtensometers
    for i = 1:plottingData(1).nVirtualExtensometers
        if plottingData(1).zoomed
            if sum([plottingData(1).zoomRect(1) < plottingData(i).monitoringPoints(1:2); plottingData(1).zoomRect(3) > plottingData(i).monitoringPoints(1:2); plottingData(1).zoomRect(2) < plottingData(i).monitoringPoints(3:4); plottingData(1).zoomRect(4) > plottingData(i).monitoringPoints(3:4)]) == 8
                plot(plottingData(i).monitoringPoints(1:2),plottingData(i).monitoringPoints(3:4),'+','Color',plottingData(1).extensometerRGB(plottingData(1).currentExtColor,:),'MarkerSize',5)
                text(plottingData(i).monitoringPoints(1),plottingData(i).monitoringPoints(3),[' ',num2str(i)],'FontSize',9,'HorizontalAlignment','Left','VerticalAlignment','Middle','Margin',35,'FontWeight','demi','Color',plottingData(1).extensometerRGB(plottingData(1).currentExtColor,:))
                text(plottingData(i).monitoringPoints(2),plottingData(i).monitoringPoints(4),[' ',num2str(i)],'FontSize',9,'HorizontalAlignment','Left','VerticalAlignment','Middle','Margin',35,'FontWeight','demi','Color',plottingData(1).extensometerRGB(plottingData(1).currentExtColor,:))
            end
        else
            plot(plottingData(i).monitoringPoints(1:2),plottingData(i).monitoringPoints(3:4),'+','Color',plottingData(1).extensometerRGB(plottingData(1).currentExtColor,:),'MarkerSize',5)
            text(plottingData(i).monitoringPoints(1),plottingData(i).monitoringPoints(3),[' ',num2str(i)],'FontSize',9,'HorizontalAlignment','Left','VerticalAlignment','Middle','Margin',35,'FontWeight','demi','Color',plottingData(1).extensometerRGB(plottingData(1).currentExtColor,:))
            text(plottingData(i).monitoringPoints(2),plottingData(i).monitoringPoints(4),[' ',num2str(i)],'FontSize',9,'HorizontalAlignment','Left','VerticalAlignment','Middle','Margin',35,'FontWeight','demi','Color',plottingData(1).extensometerRGB(plottingData(1).currentExtColor,:))
        end
    end
end

hold off
setappdata(handles_mainGui, 'plottingData', plottingData);
setappdata(handles_mainGui, 'handles', handles);
